/* TIFF tag names */
#define SubFileType          255  /* 0xFF  */
#define ImageWidth           256  /* 0x100 */
#define ImageLength          257  /* 0x101 */
#define RowsPerStrip         278  /* 0x116 */
#define StripOffsets         273  /* 0x111 */
#define StripByteCounts      279  /* 0x117 */
#define SamplesPerPixel      277  /* 0x115 */
#define BitsPerSample        258  /* 0x102 */
#define PlanarConfiguration  284  /* 0x11C */
#define Compression          259  /* 0x103 */
#define Group3Options        292  /* 0x124 */
#define Group4Options        293  /* 0x125 */
#define FillOrder            266  /* 0x10A */
#define Threshholding        263  /* 0x107 */
#define CellWidth            264  /* 0x108 */
#define CellLength           265  /* 0x109 */
#define MinSampleValue       280  /* 0x118 */
#define MaxSampleValue       281  /* 0x119 */
#define PhotometricInterp    262  /* 0x106 */
#define GrayResponseUnit     290  /* 0x122 */
#define GrayResponseCurve    291  /* 0x123 */
#define ColorResponseUnit    300  /* 0x12C */
#define ColorResponseCurves  301  /* 0x12D */
#define XResolution          282  /* 0x11A */
#define YResolution          283  /* 0x11B */
#define ResolutionUnit       296  /* 0x128 */
#define Orientation          274  /* 0x112 */
#define DocumentName         269  /* 0x10D */
#define PageName             285  /* 0x11D */
#define XPosition            286  /* 0x11E */
#define YPosition            287  /* 0x11F */
#define PageNumber           297  /* 0x129 */
#define ImageDescription     270  /* 0x10E */
#define Make                 271  /* 0x10F */
#define Model                272  /* 0x110 */
#define FreeOffsets          288  /* 0x120 */
#define FreeByteCounts       289  /* 0x121 */

/* TIFF sizes */
#define TIFFbyte             1
#define TIFFascii            2
#define TIFFshort            3
#define TIFFlong             4
#define TIFFrational         5

/* TIFF compression types */
#define COMPnone             1
#define COMPhuff             2
#define COMPfax3             3
#define COMPfax4             4
#define COMPwrdl             0x8003
#define COMPmpnt             0x8005


#define tag_count            37
typedef struct {
        int number;
        char name[20];
        } TAGNAME;

static TAGNAME tag_names[tag_count] = {
{255,"SubFileType"},{256,"ImageWidth"},
{257,"ImageLength"},{278,"RowsPerStrip"},
{273,"StripOffsets"},{279,"StripByteCounts"},
{277,"SamplesPerPixel"},{258,"BitsPerSample"},
{284,"PlanarConfiguration"},{259,"Compression"},
{292,"Group3Options"},{293,"Group4Options"},
{266,"FillOrder"},{263,"Threshholding"},
{264,"CellWidth"},{265,"CellLength"},
{280,"MinSampleValue"},{281,"MaxSampleValue"},
{262,"PhotometricInterp"},{290,"GrayResponseUnit"},
{291,"GrayResponseCurve"},{300,"ColorResponseUnit"},
{301,"ColorResponseCurves"},{282,"XResolution"},
{283,"YResolution"},{296,"ResolutionUnit"},
{274,"Orientation"},{269,"DocumentName"},
{285,"PageName"},{286,"XPosition"},
{287,"YPosition"},{297,"PageNumber"},
{270,"ImageDescription"},{271,"Make"},
{272,"Model"},{288,"FreeOffsets"},
{289,"FreeByteCounts"},
};


char *tag_name(int n)

{
     int i;
     for(i=0;i<tag_count;++i) {
             if(n==tag_names[i].number)
               return(tag_names[i].name);
     }
     return("BadTag");
}
